// vimeo on WoozTalk
// (c) 2009 Kurioos iTech

function dump(msg) {
/*    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage(msg);*/
}

function LOG(msg) {
    dump(msg);
}

var vimeoOnWoozTalk = (function(){try {
	var plugin_name = "vimeo";
	var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;

	var lasturl = null;
	var message = [];
	var wmessage = null;

	var html_entity_decode = function(t) {
	  if (/&[#a-zA-Z0-9]{1,10};/.test(t) == false) {
	    return cleanStr(t);
	  } else {
	    var str = "<div>"+cleanStr(t).replace(/</g, "&lt;").replace(/>/g,"&gt;")+"</div>";
	    var e = (new DOMParser()).parseFromString(str, 'text/xml');
	    if (e.documentElement.nodeName == "parsererror") {
	        return cleanStr(t);
  	    } else {
	        return e.documentElement.textContent;
  	    }
	  }
	}

	var cleanStr = function(s) {
	    return s.replace(/\\0/g,'').replace(/[\n\r]/g,' ').replace(/^[ \t]+/g,'').replace(/[ \t]+$/g,'');
	}

	var sendToWoozTalk = function(args) {
	    if (args.length < 2) {
		if (lasturl != null) {
		    sendCloseURL(lasturl, false);
		}
		lasturl = null;
		unregister_wooztalk();
		return ;
	    }
	    var newurl = "media://"+encodeURIComponent(args[0])+"/"+encodeURIComponent(args[1]);
	    if (lasturl != newurl) {
		register_wooztalk();
		sendOpenURL(newurl);
		if (lasturl != null) {
		    sendCloseURL(lasturl, false);
		}
		lasturl = newurl;
	    }
	}
	
	function update(a) {
	    if(wmessage == a) {
		sendToWoozTalk(message);
	    }
	}
	
	function hide() {
	    sendToWoozTalk([]);
	}

	function callInProgress(xmlhttp) {
	    switch (xmlhttp.readyState) {
		case 1, 2, 3:
		    return true;
		    break;
		    // Case 4 and 0
		default:
		    return false;
		    break;
	    }
	}

	var sendOpenURL = function(url)
	{
	    url = url.toLowerCase();
	    var p = new XMLHttpRequest();
	    var timeoutId = window.setTimeout(function() { if (callInProgress(p)) { p.abort(); } }, 5000);
	    p.onreadystatechange = function(evt) {
		try {
		    if(this.readyState == 4) {
			if (this.responseXML != null) {
			    var count = this.responseXML.documentElement.getAttribute("users");
			    var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			    nbr.value = count;
			} else {
			    var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			    nbr.value = "??";
			}
		    }
		} catch (e) { LOG("Exception open: "+e); }
	    };
	    p.onerror = function(e) {
		if (callInProgress(this)) { 
		    this.abort(); 
		}
		var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
		nbr.value = "WoozTalk not launched?";
	    };
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/open/"+url, true);
	    p.send(null);
	}

	var sendCloseURL = function(url, sync)
	{
	    url = url.toLowerCase();
	    try {
		var p = new XMLHttpRequest();
		var timeoutId = window.setTimeout(function() { if (callInProgress(p)) { p.abort(); } }, 5000);
		if (!sync) {
		    p.onreadystatechange = function() { };
		    p.onerror = function(e) {
			if (callInProgress(this)) { 
			    this.abort(); 
			}
			var nbr = document.getElementById(plugin_name+'onwooztalk-statusbar-nbr');
			nbr.value = "WoozTalk not launched?";
		    };
		}
		p.open("GET", "http://localhost:6788/"+plugin_name+"/close/"+url, !sync);
		p.send(null);
	    } catch (e) {
		LOG("Exception in close : "+e);
	    }
	}

	var register_wooztalk = function()
	{
	    var p = new XMLHttpRequest();
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/check/", true);
	    p.send(null);

	    var stat = document.getElementById(plugin_name+'onwooztalk-status');
	    stat.collapsed = false;
	}

	var unregister_wooztalk = function()
	{
	    var p = new XMLHttpRequest();
	    p.open("GET", "http://localhost:6788/"+plugin_name+"/quit/", false);
	    p.send(null);

	    var stat = document.getElementById(plugin_name+'onwooztalk-status');
	    stat.collapsed = true;
	}


	/* Partie spécifique à vimeo */
	var pageListener = function(aEvent) {
	    var doc = aEvent.originalTarget;
	    function checkdoc() {
		try {
		    if(!doc 
			    || doc.nodeName != "#document" 
			    || !doc.location 
			    || typeof doc.location.hostname != 'string' 
			    || !doc.location.hostname.match(/vimeo.com/)
		      )
			throw null; 
		} catch(e) { 
		    return false; 
		} 
		return true;
	    }

	    function changeTitle(main_element)
	    {
		var links = main_element.getElementsByTagName("DIV");
		var title = "";
		var author = "";
		for (var i = 0; i < links.length; i++) {
		    if (links[i].className == "title") {
			if (links[i].firstChild.tagName == "A") {
			    title = links[i].firstChild.innerHTML;
			} else {
			    title = links[i].innerHTML;
			}
			break;
			/*	} else if (links[i].className == "byline") {
				author = links[i].innerHTML;
				alert("Auteur : "+author);*/
		    }
		}
		if (title != "") {
		    message = ["", cleanStr(title)];
		    wmessage = doc;
		    update(wmessage);
		}
	    }

	    function currentTitleChanged(evt)
	    {
		var main_element = evt.target;
		changeTitle(main_element);
	    }

	    function checker() {
		if(!checkdoc()) {
		    return false;
		}
		var main_element;
		main_element = doc.getElementById("video_stuff");
		if (main_element == undefined) {
		    main_element = doc.getElementById("header");
		} else {
		    main_element.addEventListener("DOMSubtreeModified", currentTitleChanged, false);
		}

		if (main_element != null) {
		    changeTitle(main_element);
		}
	    }
	    if(checkdoc()) {
		checker();
		doc.defaultView.addEventListener("unload", pageUnloadListener,false);
	    }
	    return true;
	};
	var pageUnloadListener = function(aEvent) {
	    var doc = aEvent.originalTarget;
	    if(doc == wmessage) {
		hide();
	    }
	}

	window.addEventListener("DOMContentLoaded", function() {
		document.getElementById("appcontent").addEventListener("DOMContentLoaded", pageListener,false);
		},false);

	window.addEventListener("unload", function() {
		document.getElementById("appcontent").removeEventListener("DOMContentLoaded", pageListener,false);
		hide();
		},false);

    var UninstallObserver = {
_uninstall : false,
	     observe : function(subject, topic, data) {
		 if (topic == "em-action-requested") {
		     subject.QueryInterface(Components.interfaces.nsIUpdateItem);

		     if (subject.id == plugin_name+"onwooztalk@wooztalk.com") {
			 if (data == "item-uninstalled") {
			     this._uninstall = true;
			 } else if (data == "item-cancel-action") {
			     this._uninstall = false;
			 }
		     }
		 } else if (topic == "quit-application-granted") {
		     if (this._uninstall) {
			 alert("Merci de relancer WoozTalk pour prendre en compte la désinstallation du plugin.\n\nPlease restart WoozTalk to update plugins' list.");
			 var file_target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name);
			 if (file_target.exists()) {
			     file_target.remove(true);
			 }
		     }
		     this.unregister();
		 }
	     },
register : function() {
	       var observerService =
		   Components.classes["@mozilla.org/observer-service;1"].
		   getService(Components.interfaces.nsIObserverService);

	       observerService.addObserver(this, "em-action-requested", false);
	       observerService.addObserver(this, "quit-application-granted", false);
	   },
unregister : function() {
		 var observerService =
		     Components.classes["@mozilla.org/observer-service;1"].
		     getService(Components.interfaces.nsIObserverService);

		 observerService.removeObserver(this,"em-action-requested");
		 observerService.removeObserver(this,"quit-application-granted");
	     }
	};


	    var get_path = function(id, path) {
		var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		var file = em.getInstallLocation(id).getItemFile(id, path);
		return file;
	    };


	var main = function(event) {
	    var countWindows = function() {
		LOG("countWindows START");
		UninstallObserver.register();
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		    .getService(Components.interfaces.nsIWindowMediator);
		var enumerator = wm.getEnumerator("navigator:browser");
		var counter = 0;
		LOG("Count !");
		while(enumerator.hasMoreElements()) {
		    var win = enumerator.getNext();
		    counter = counter + 1;
		}
		LOG("countWindows END");
		return counter;
	    };

	    var copy_file = function(filename, target)
	    {
		var file_source = get_path(plugin_name+"onwooztalk@wooztalk.com", "install/"+filename);
		var file_target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name+"/"+filename);
		if (!file_source.exists()) {
		    alert("Erreur : fichiers manquants pour compléter l'installation");
		} else if (!file_target.exists() 
			|| Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS == "Linux" ) {
		    file_source.copyTo(target, null);
		}
	    };

	    window.removeEventListener("load", main, false);
	    if (countWindows() == 1) {
		try {
		    var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
		    if (!em.getInstallLocation("firefoxonwooztalk@wooztalk.com")) {
			if (osString == "Linux") {
			    alert(plugin_name+" on WoozTalk nécessite l'installation préalable de WoozTalk pour fonctionner.\n\n"+plugin_name+" on WoozTalk requires WoozTalk to run.");
			    window.setTimeout(function() { window._content.document.location = "http://www.wooztalk.com/download/"; }, 2000);
			}
			return ;
		    }

		    var target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk");
		    if (!target.exists()) {
			return ;
		    }

		    var target = get_path("firefoxonwooztalk@wooztalk.com", "wooztalk/plugins/"+plugin_name);
		    if (osString == "WINNT") {
			copy_file(plugin_name+".dll", target);
		    } else {
			copy_file("lib"+plugin_name+".so", target);
		    }
		    copy_file(plugin_name+".png", target);
		    copy_file(plugin_name+"_dis.png", target);
		} catch (e) {
		    alert(e);
		}
	    }
	};
	window.addEventListener("load", main, false);

} catch(e) {
    dump('vimeoOnWoozTalk : '+e);
}
})();
